// AttributeSet.h: interface for the CAttributeSet class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ATTRIBUTESET_H__84076E61_071A_11D3_A77E_00902744149A__INCLUDED_)
#define AFX_ATTRIBUTESET_H__84076E61_071A_11D3_A77E_00902744149A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Afxtempl.h>

#include "Attribute.h"

class CFDSet;

class CAttributeSet
{
//Implement
protected:
	CList<CAttribute, CAttribute&> m_attList;
	POSITION m_rPosition;
	int m_nIndex;

//	void DelRepeat();
public:
	CAttributeSet();
	CAttributeSet(CAttribute&);
	CAttributeSet(CAttributeSet&);
	virtual ~CAttributeSet();

	int GetCount() const;

	void GoHeadPosition();
	void GoIndex(int);

	void AddAtt(CAttribute&);
	void DelAtt(CAttribute&);

	CAttribute GetAtt() const;

	BOOL IsMemberOf(CAttribute);
	BOOL IsMemberOf(CAttributeSet);

	POSITION Find(CAttribute);
	void RemoveAtt(int);

	CAttributeSet Closure(CFDSet);
	CAttributeSet GetSubSet(int);		//̰ ¥
	CAttributeSet GetSubSet(int, int);	//̰ ׳ 

	BOOL IsEmpty() const;
	void Empty();

	CAttributeSet operator+(CAttributeSet&);
	CAttributeSet operator-(CAttribute&);
	CAttributeSet operator-(CAttributeSet&);
	const CAttributeSet& operator=(CAttribute&);
	const CAttributeSet& operator=(CAttributeSet&);
	const CAttributeSet& operator+=(CAttribute&);
	const CAttributeSet& operator+=(CAttributeSet&);
	const CAttributeSet& operator-=(CAttribute&);
	const CAttributeSet& operator-=(CAttributeSet&);
	

	void operator++();
	void operator++(int);
	void operator--();
	void operator--(int);
	BOOL operator==(CAttributeSet&);
	BOOL operator!=(CAttributeSet&);

	CString GetstrAtt();
};

#endif // !defined(AFX_ATTRIBUTESET_H__84076E61_071A_11D3_A77E_00902744149A__INCLUDED_)
