// DataBase.cpp: implementation of the CDataBase class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Normalization.h"
#include "DataBase.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDataBase::CDataBase()
{
	m_nIndex=0;
	m_rPosition=NULL;
}

CDataBase::CDataBase(CDataBase& dbInput)
{
	*this=dbInput;
}

CDataBase::~CDataBase()
{

}

int CDataBase::GetCount()
{
	return m_relList.GetCount();
}

void CDataBase::SetRelation(CRelation relInput)
{
	m_relRelation=relInput;
}

void CDataBase::AddRel(CRelation relInput)
{
	this->DelRel(relInput);
	m_relList.AddTail(relInput);
}

void CDataBase::DelRel(CRelation relInput)
{
	int nIndex=m_nIndex;
	POSITION rPosition=m_rPosition;

	int nLenOfRelList=m_relList.GetCount();
	CRelation relTemp;

	this->GoHeadPosition();
	for(int i=0; i<nLenOfRelList; i++)
	{
		POSITION rPosition=m_rPosition;

		relTemp=this->GetRel();
		this->operator ++();

		if(relTemp==relInput)
		{
			m_relList.RemoveAt(rPosition);
			break;
		}

	}

	m_nIndex=nIndex;
	if(m_nIndex>=m_relList.GetCount())
		m_nIndex=m_relList.GetCount()-1;
	else
		if(m_nIndex<0)
			m_nIndex=0;
	m_rPosition=m_relList.FindIndex(m_nIndex);

}

POSITION CDataBase::GetHeadPosition()
{
	return m_relList.GetHeadPosition();
}

CRelation CDataBase::GetRel()
{
	CRelation relTemp=m_relList.GetAt(m_rPosition);
	return relTemp;
}

CRelation CDataBase::GetRel(POSITION& rPosition)
{
	return m_relList.GetNext(rPosition);
}

CRelation CDataBase::GetRelation()
{
	return m_relRelation;
}

void CDataBase::GoHeadPosition()
{
	m_rPosition=m_relList.GetHeadPosition();
	m_nIndex=0;
}

void CDataBase::RemoveRedundant(CRelation relUi)
{
	CString strTemp;

	strTemp=relUi.GetstrRel();

	CDataBase dbDB;
	dbDB=*this;

	strTemp=dbDB.GetstrRel();

	dbDB.DelRel(relUi);

	strTemp=dbDB.GetstrRel();

	CRelation relTrue;
	relTrue.SetKey(relUi.GetKey());
	relTrue.SetFDSet(relUi.GetFDSet());

	strTemp=relTrue.GetstrFD();

	CRelation relRs;
	int nLenOfRelList=dbDB.GetCount();

	dbDB.GoHeadPosition();
	for(int i=0; i<nLenOfRelList; i++)
	{
		relRs=dbDB.GetRel();
		dbDB++;

		strTemp=relRs.GetstrRel();

		if(relRs.GetKey()==relUi.GetKey())
		{
			this->DelRel(relRs);
			relTrue.SetFDSet(relTrue.GetFDSet()+relRs.GetFDSet());
	
			strTemp=relTrue.GetstrFD();

		}
	}

	m_relList.AddTail(relTrue);
}

void CDataBase::Empty()
{
	m_relList.RemoveAll();
	m_nIndex=0;
	m_rPosition=NULL;
}

CDataBase& CDataBase::operator =(CDataBase& dbInput)
{
//	if(this==&dbInput)
//		return *this;

	const int nLenOfRelList=dbInput.GetCount();
	CRelation relTemp;
	m_relList.RemoveAll();

	dbInput.GoHeadPosition();
	for(int i=0; i<nLenOfRelList; i++)
	{
		relTemp=dbInput.GetRel();
		dbInput++;

		m_relList.AddTail(relTemp);
	}

	m_nIndex=0;
	m_rPosition=m_relList.GetHeadPosition();

	return *this;
}


void CDataBase::operator ++()
{
	m_nIndex++;
	if(m_nIndex>=m_relList.GetCount())
		m_nIndex=m_relList.GetCount()-1;
	else
		m_rPosition=m_relList.FindIndex(m_nIndex);
}

void CDataBase::operator ++(int)
{
	this->operator ++();
}

CString CDataBase::GetstrRel()
{
	CRelation relTemp;
	CString strTemp;
	int nLenOfRelList=m_relList.GetCount();

	this->GoHeadPosition();
	for(int i=0; i<nLenOfRelList; i++)
	{
		relTemp=this->GetRel();
		this->operator ++();

		strTemp+=relTemp.GetstrRel();
	}
	
	return strTemp;
}