// EditFDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Normalization.h"
#include "NormalizationDoc.h"
#include "NormalizationView.h"
#include "MainFrm.h"
#include "EditFDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditFDDlg dialog


CEditFDDlg::CEditFDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditFDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditFDDlg)
	//}}AFX_DATA_INIT
}


void CEditFDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditFDDlg)
	DDX_Control(pDX, IDC_LISTFDRIGHT, m_listBoxFDRight);
	DDX_Control(pDX, IDC_LISTFD, m_listBoxFD);
	DDX_Control(pDX, IDC_LISTFDLEFT, m_listBoxFDLeft);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditFDDlg, CDialog)
	//{{AFX_MSG_MAP(CEditFDDlg)
	ON_BN_CLICKED(IDC_ADDFD, OnAddfd)
	ON_BN_CLICKED(IDC_DELFD, OnDelfd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditFDDlg message handlers

void CEditFDDlg::OnOK() 
{
	// TODO: Add extra validation here
	// main document Ѵ.
	CMainFrame* pFrame;
	pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	CNormalizationView* pView;
	pView=(CNormalizationView*)pFrame->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	CRelation relTemp=pDoc->m_dbRelation.GetRelation();

	relTemp.SetFDSet(m_fdset);

	pDoc->m_dbRelation.SetRelation(relTemp);

	pDoc->m_b1NF=FALSE;
	pDoc->m_b2NF=FALSE;
	pDoc->m_b3NF=FALSE;
	pDoc->m_bBCNF=FALSE;

	CDialog::OnOK();
}

void CEditFDDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

BOOL CEditFDDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	// main document Ѵ.

	return CDialog::PreCreateWindow(cs);
}

BOOL CEditFDDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CString strTemp;

	CMainFrame* pFrame;
	pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	CNormalizationView* pView;
	pView=(CNormalizationView*)pFrame->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	CRelation relTemp=pDoc->m_dbRelation.GetRelation();

	CAttributeSet attsetKey=relTemp.GetKey();
	CFDSet fdset=relTemp.GetFDSet();

	strTemp=attsetKey.GetstrAtt();
	strTemp=fdset.GetstrFD();

	const int nSizeAttSet=attsetKey.GetCount();
	const int nSizeFDSet=fdset.GetCount();

	attsetKey.GoHeadPosition();
	for(int i=0; i<nSizeAttSet; i++)
	{
		CAttribute attKey=attsetKey.GetAtt();
		attsetKey++;

		strTemp=attKey.GetAttName();

		m_listBoxFDLeft.AddString(strTemp);
		m_listBoxFDRight.AddString(strTemp);
	}

	fdset.GoHeadPosition();
	for(i=0; i<nSizeFDSet; i++)
	{
		CFD fdFD=fdset.GetFD();
		fdset++;

		strTemp=fdFD.GetstrFD();

		m_listBoxFD.AddString(fdFD.GetstrFD());
	}

	m_fdset=fdset;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditFDDlg::OnAddfd() 
{
	// TODO: Add your control notification handler code here

	CString strTemp;

	const int nSizeFDLeft=m_listBoxFDLeft.GetCount();
	CAttributeSet attsetLHS;
	CAttributeSet attsetRHS;

	int j=0;
	for(int i=0; i<nSizeFDLeft; i++)
	{
		if(m_listBoxFDLeft.GetSel(i)>0)
		{
			CString strKey;
			m_listBoxFDLeft.GetText(i, strKey);
			attsetLHS+=(CAttribute)strKey;
		}
	}

	const int nSizeFDRight=m_listBoxFDRight.GetCount();

	for(i=0; i<nSizeFDLeft; i++)
	{
		if(m_listBoxFDRight.GetSel(i)>0)
		{
			CString strKey;
			m_listBoxFDRight.GetText(i, strKey);
			attsetRHS+=(CAttribute)strKey;
		}
	}

	CFD fdFD;
	CAttributeSet attsetTemp=attsetRHS-attsetLHS;
	if(attsetTemp.GetCount()>0)
	{
		fdFD.SetLHS(attsetLHS);
		fdFD.SetRHS(attsetTemp);

		if(m_fdset.IsMemberOf(fdFD)==FALSE)
		{
			strTemp=m_fdset.GetstrFD();

			m_fdset.AddFD(fdFD, TRUE);
			m_listBoxFD.AddString(fdFD.GetstrFD());

			strTemp=m_fdset.GetstrFD();
		}
	}
}
void CEditFDDlg::OnDelfd() 
{
	// TODO: Add your control notification handler code here
	int nSizeFD=m_listBoxFD.GetCount();

	CString strTemp;

	for(int i=0; i<nSizeFD; i++)
	{
		if(m_listBoxFD.GetSel(i)>0)
		{
			CString strFD;
			m_listBoxFD.GetText(i, strFD);
			
			int nSizeFDSet=m_fdset.GetCount();
			m_fdset.GoHeadPosition();
			for(int j=0; j<nSizeFDSet; j++)
			{
				CFD fdFD=m_fdset.GetFD();
				m_fdset++;

				CString str=fdFD.GetstrFD();
				if(fdFD.GetstrFD()==strFD)
				{
					strTemp=m_fdset.GetstrFD();

					m_fdset.Remove(fdFD);

					strTemp=m_fdset.GetstrFD();
					break;
				}
			}

			m_listBoxFD.DeleteString(i);
			i--;
			nSizeFD--;
		}
	}
}
