// FD.cpp: implementation of the CFD class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Normalization.h"
#include "FD.h"
#include "FDSet.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFD::CFD()
{

}

CFD::CFD(CFD &fdInput)
{
	*this=fdInput;
}

CFD::~CFD()
{

}

CAttributeSet CFD::GetLHS()
{
	return m_attsetLHS;
}

CAttributeSet CFD::GetRHS()
{
	return m_attsetRHS;
}

void CFD::SetLHS(CAttributeSet attsetInput)
{
	m_attsetLHS=attsetInput;
}

void CFD::SetRHS(CAttributeSet attsetInput)
{
	m_attsetRHS=attsetInput;
}

void CFD::AddLHS(CAttributeSet attsetInput)
{
	m_attsetLHS+=attsetInput;
}

void CFD::AddRHS(CAttributeSet attsetInput)
{
	m_attsetRHS+=attsetInput;
}

BOOL CFD::IsMemberOf(CFDSet fdsetInput)
{
	int nLengthList=m_attsetRHS.GetCount();
	CAttribute attTemp;
	CAttributeSet attsetClosure=m_attsetLHS.Closure(fdsetInput);

	m_attsetRHS.GoHeadPosition();
	for(int i=0; i<nLengthList; i++)
	{
		attTemp=m_attsetRHS.GetAtt();
		m_attsetRHS++;

		if(attsetClosure.IsMemberOf(attTemp)==false)
			return false;
	}
	return true;
}

BOOL CFD::IsRedundant(CFDSet fdsetInput)
{
	CFDSet fdsetTemp=fdsetInput;

	fdsetTemp.Remove(*this);

	if(m_attsetLHS.Closure(fdsetTemp).IsMemberOf(m_attsetRHS)==TRUE)
		return TRUE;
	return FALSE;
}

const CFD& CFD::operator =(CFD& fdInput)
{
	m_attsetLHS=fdInput.GetLHS();
	m_attsetRHS=fdInput.GetRHS();
	return *this;
}

BOOL CFD::operator ==(CFD& fdInput)
{
	if(m_attsetLHS==fdInput.GetLHS())
		if(m_attsetRHS==fdInput.GetRHS())
			return TRUE;
	return FALSE;
}

BOOL CFD::operator !=(CFD& fdInput)
{
	return (!operator==(fdInput));
}

CString CFD::GetstrLHS()
{
	return m_attsetLHS.GetstrAtt();	
}

CString CFD::GetstrRHS()
{
	return m_attsetRHS.GetstrAtt();
}

CString CFD::GetstrFD()
{
	return m_attsetLHS.GetstrAtt()+" -> "+m_attsetRHS.GetstrAtt();
}

