// FDSet.h: interface for the CFDSet class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FDSET_H__84076E63_071A_11D3_A77E_00902744149A__INCLUDED_)
#define AFX_FDSET_H__84076E63_071A_11D3_A77E_00902744149A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <Afxtempl.h>
#include "FD.h"

class CFDSet  
{
protected:
	CList<CFD, CFD&> m_fdList;
	int m_nIndex;
	POSITION m_rPosition;

//	void DelRepeat();
public:
	CFDSet();
	CFDSet(CFD&);
	CFDSet(CFDSet&);
	virtual ~CFDSet();

	int GetCount();
	
	void AddFD(CFD, int);
	CFD GetFD();
	int GetIndex();

	void Remove(CFD);

	void GoHeadPosition();
	void GoIndex(int);

	BOOL IsMemberOf(CFD);
	BOOL IsMemberOf(CFDSet);

	BOOL IsEmpty();
	void Empty();

	CFDSet GetSubSet(int, int);

	CAttributeSet GetCover();		// fdset coverϴ attribute set ã´.
	CAttributeSet GetDeterminant();	// fdset determinant set ã´.

	CFDSet DelRedundant();
	CFDSet DelRedundant(CAttributeSet);

	CFDSet DelUesless(CAttributeSet);

	CFDSet NonRedundantCover();
	CFDSet LeftReducedCover();
	CFDSet CanonicalCover();
	CFDSet MinumumCover();
	
	BOOL HasMember(CFD);
	BOOL IsDerives(CFDSet);
	BOOL IsDirectDerives(CAttributeSet, CAttributeSet);
	BOOL IsEquivalent(CFDSet);
	BOOL IsEquivalent(CAttributeSet, CAttributeSet);
	BOOL IsRedundant();
	CFDSet EquivClass(CAttributeSet);


	CFDSet operator+(CFDSet&);
	CFDSet operator-(CFD&);
	CFDSet operator-(CFDSet&);
	CFDSet& operator=(CFD&);
	CFDSet& operator=(CFDSet&);
	CFDSet& operator+=(CFD&);
	CFDSet& operator+=(CFDSet&);
	CFDSet& operator-=(CFD&);
	CFDSet& operator-=(CFDSet&);


	void operator++();
	void operator++(int);
	void operator--();
	void operator--(int);
	BOOL operator==(CFDSet&);
	BOOL operator!=(CFDSet&);

	CString GetstrFD();
};


#endif // !defined(AFX_FDSET_H__84076E63_071A_11D3_A77E_00902744149A__INCLUDED_)
