// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Normalization.h"
#include "NormalizationDoc.h"
#include "NormalizationView.h"
#include "MainFrm.h"

#include "TestDlg.h"
#include "MakeRelDlg.h"
#include "EDitFDDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_COMMAND_EX(CG_ID_VIEW_NORMALDLALOGBAR, OnBarCheck)
	ON_UPDATE_COMMAND_UI(CG_ID_VIEW_NORMALDLALOGBAR, OnUpdateControlBarMenu)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_APP_TESTDLG, OnAppTestdlg)
	ON_COMMAND(ID_APP_RELATION, OnAppRelation)
	ON_COMMAND(ID_APP_FD, OnAppFd)
	ON_COMMAND(ID_APP_BCNF, OnAppBcnf)
	ON_COMMAND(ID_APP_1NF, OnApp1nf)
	ON_COMMAND(ID_APP_2NF, OnApp2nf)
	ON_COMMAND(ID_APP_3NF, OnApp3nf)
	ON_BN_CLICKED(IDC_RADIO_1NF, OnRadio1nf)
	ON_BN_CLICKED(IDC_RADIO_2NF, OnRadio2nf)
	ON_BN_CLICKED(IDC_RADIO_3NF, OnRadio3nf)
	ON_BN_CLICKED(IDC_RADIO_4NF, OnRadio4nf)
	ON_CBN_SELCHANGE(IDC_COMBO_OUT_REL, OnSelchangeComboOutRel)
	ON_COMMAND(ID_APP_ATTRIBUTE, OnAppAttribute)
	ON_CBN_SELCHANGE(IDC_COMBO_OUT_DIAGRAM, OnSelchangeComboOutDiagram)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_pDlg=NULL;
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetWindowText("Normalization Tool by JOE for DB99");	// added by eliot. for window title 

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	if(!m_wndDialogBar.Create(this, CG_IDD_NORMALDIALOG, CBRS_LEFT | CBRS_TOOLTIPS |
		CBRS_FLYBY | CBRS_HIDE_INPLACE, CG_IDD_NORMALDIALOG))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndDialogBar.EnableDocking(CBRS_ALIGN_LEFT | CBRS_ALIGN_RIGHT);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndDialogBar);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style &= ~FWS_ADDTOTITLE ;		// added by eliot. 

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnAppTestdlg() 
{
	// TODO: Add your command handler code here
	CTestDlg *pDlg=new CTestDlg;
	pDlg->DoModal();
	delete pDlg;
}

void CMainFrame::OnAppRelation() 
{
	// TODO: Add your command handler code here
	CAttributeSet attsetTemp;
	attsetTemp=(CAttributeSet)(CAttribute)"a"+(CAttributeSet)(CAttribute)"b"+
		(CAttributeSet)(CAttribute)"c"+(CAttributeSet)(CAttribute)"d";

	CAttributeSet temp=attsetTemp.GetSubSet(10, 4);
	CString strTemp=temp.GetstrAtt();

	CMakeRelDlg *pDlg=new CMakeRelDlg;
	pDlg->DoModal();
	delete pDlg;

	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();
	
	CRelation relRelation=pDoc->m_dbRelation.GetRelation();
	CAttributeSet attsetKey=relRelation.GetKey();

	strTemp=pDoc->m_dbRelation.GetstrRel();

	CListBox* pListBox;
	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_IN_ATT);
	
	pListBox->ResetContent();	

	const int nNumKey=attsetKey.GetCount();
	attsetKey.GoHeadPosition();
	for(int i=0; i<nNumKey; i++)
	{
		CAttribute attKey=attsetKey.GetAtt();
		attsetKey++;

		pListBox->AddString(attKey.GetAttName());
	}

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_IN_FD);

	pListBox->ResetContent();
	CFDSet fdset=relRelation.GetFDSet();
	const int nNumFD=fdset.GetCount();
	fdset.GoHeadPosition();
	for(int cJ=0; cJ<nNumFD; cJ++)
	{
		CFD fdFD=fdset.GetFD();
		fdset++;

		pListBox->AddString(fdFD.GetstrFD());
	}

	CComboBox* pCheckCom;
	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);
	pCheckCom->ResetContent();

	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);
	pCheckCom->ResetContent();
	
	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);
	pListBox->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);
	pListBox->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);
	pListBox->ResetContent();
	pDoc->m_bDraw=FALSE;
	Invalidate(TRUE);
}

void CMainFrame::OnAppFd() 
{
	// TODO: Add your command handler code here
	CEditFDDlg* pDlg=new CEditFDDlg;
	pDlg->DoModal();
	delete pDlg;

	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();
	
	CRelation relRelation=pDoc->m_dbRelation.GetRelation();
	CAttributeSet attsetKey=relRelation.GetKey();


	CListBox* pListBox;
	
	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_IN_FD);

	pListBox->ResetContent();
	CFDSet fdset=relRelation.GetFDSet();
	const int nNumFD=fdset.GetCount();
	fdset.GoHeadPosition();
	for(int cJ=0; cJ<nNumFD; cJ++)
	{
		CFD fdFD=fdset.GetFD();
		fdset++;

		pListBox->AddString(fdFD.GetstrFD());
	}

	CComboBox* pCheckCom;
	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);

	pCheckCom->ResetContent();

	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);

	pCheckCom->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);
	pListBox->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);
	pListBox->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);
	pListBox->ResetContent();
	pDoc->m_bDraw=FALSE;
	Invalidate(TRUE);
}


void CMainFrame::OnApp1nf() 
{
	// TODO: Add your command handler code here
	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	// 1NF  ʾҴٸ 1NF .
	if(pDoc->m_b1NF==FALSE)
	{
		pDoc->m_rel1NF=pDoc->m_dbRelation.GetRelation().Find1NF();
		pDoc->m_b1NF=TRUE;
	}

	pDoc->m_nSel=1;
	pDoc->m_bDraw=FALSE;
	Invalidate(TRUE);
/*	if(m_pDlg!=NULL)
	{
		m_pDlg->SetFocus();
	}
	else
	{
		m_pDlg=new COutputDlg;
		m_pDlg->Create(this);
		m_pDlg->ShowWindow(SW_SHOW);
	}
	*/
}

void CMainFrame::OnApp2nf() 
{
	// TODO: Add your command handler code here
	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	// 2NF  ʾҴٸ 2NF .
	if(pDoc->m_b2NF==FALSE)
	{
		// 1NF  ʾҴٸ 1NF .
		if(pDoc->m_b1NF==FALSE)
		{
			pDoc->m_rel1NF=pDoc->m_dbRelation.GetRelation().Find1NF();
			pDoc->m_b1NF=TRUE;
		}
		pDoc->m_db2NF=pDoc->m_dbRelation.GetRelation().Find2NF(pDoc->m_rel1NF);
		pDoc->m_b2NF=TRUE;
	}

	pDoc->m_nSel=2;
	pDoc->m_bDraw=FALSE;	
	Invalidate(TRUE);
	/*
	if(m_pDlg!=NULL)
	{
		m_pDlg->SetFocus();
	}
	else
	{
		pDoc->m_db2NF.GoHeadPosition();
		m_pDlg=new COutputDlg;
		m_pDlg->Create(this);
		m_pDlg->ShowWindow(SW_SHOW);
	}
*/
}

void CMainFrame::OnApp3nf() 
{
	// TODO: Add your command handler code here
	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	// 3NF  ʾҴٸ 3NF .
	if(pDoc->m_b3NF==FALSE)
	{
		// 1NF  ʾҴٸ 1NF .
		if(pDoc->m_b1NF==FALSE)
		{
			pDoc->m_rel1NF=pDoc->m_dbRelation.GetRelation().Find1NF();
			pDoc->m_b1NF=TRUE;
		}

		// 2NF  ʾҴٸ 2NF .
		if(pDoc->m_b2NF==FALSE)
		{
			pDoc->m_db2NF=pDoc->m_dbRelation.GetRelation().Find2NF(pDoc->m_rel1NF);
			pDoc->m_b2NF=TRUE;
		}

		pDoc->m_db3NF=pDoc->m_dbRelation.GetRelation().Find3NF(pDoc->m_db2NF);
		pDoc->m_b3NF=TRUE;
	}
	pDoc->m_nSel=3;

	pDoc->m_bDraw=FALSE;
	Invalidate(TRUE);
	/*	if(m_pDlg!=NULL)
	{
		m_pDlg->SetFocus();
	}
	else
	{
		pDoc->m_db3NF.GoHeadPosition();
		m_pDlg=new COutputDlg;
		m_pDlg->Create(this);
		m_pDlg->ShowWindow(SW_SHOW);
	}
	*/
}

void CMainFrame::OnAppBcnf( )
{
	// TODO: Add your command handler code here
	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();
	
	// BCNF  ʾҴٸ BCNF .
	if(pDoc->m_bBCNF==FALSE)
	{
		// 1NF  ʾҴٸ 1NF .
		if(pDoc->m_b1NF==FALSE)
		{
			pDoc->m_rel1NF=pDoc->m_dbRelation.GetRelation().Find1NF();
			pDoc->m_b1NF=TRUE;
		}

		// 2NF  ʾҴٸ 2NF .
		if(pDoc->m_b2NF==FALSE)
		{
			pDoc->m_db2NF=pDoc->m_dbRelation.GetRelation().Find2NF(pDoc->m_rel1NF);
			pDoc->m_b2NF=TRUE;
		}

		// 3NF  ʾҴٸ 3NF .
		if(pDoc->m_b3NF==FALSE)
		{
			pDoc->m_db3NF=pDoc->m_dbRelation.GetRelation().Find3NF(pDoc->m_db2NF);
			pDoc->m_b3NF=TRUE;
		}

		pDoc->m_dbBCNF=pDoc->m_dbRelation.GetRelation().FindBCNF(pDoc->m_db3NF);
		pDoc->m_bBCNF=TRUE;
	}

	pDoc->m_nSel=4;

	pDoc->m_bDraw=FALSE;
	Invalidate(TRUE);
/*
	if(m_pDlg!=NULL)
	{
		m_pDlg->SetFocus();
	}
	else
	{
		pDoc->m_dbBCNF.GoHeadPosition();
		m_pDlg=new COutputDlg;
		m_pDlg->Create(this);
		m_pDlg->ShowWindow(SW_SHOW);
	}
*/
}

void CMainFrame::OnRadio1nf() 
{
	// TODO: Add your control notification handler code here
	CButton* pCheck;
	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_1NF);

	if(pCheck->GetCheck())
	{
		this->OnApp1nf();

		CNormalizationView* pView;
		pView=(CNormalizationView*)this->GetActiveView();
		CNormalizationDoc* pDoc;
		pDoc=pView->GetDocument();

		CComboBox* pComboBox;
		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);

		pComboBox->ResetContent();

		CString strItem;
		strItem.Format("R0");
		pComboBox->AddString(strItem);

		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);

		pComboBox->ResetContent();
		
		pComboBox->AddString(pDoc->m_dbRelation.GetRelation().GetRelName());
		strItem.Format("R0");
		pComboBox->AddString(strItem);


		pDoc->m_dbRelation.GoHeadPosition();
		CRelation relRelation=pDoc->m_rel1NF;
		CAttributeSet attsetKey=relRelation.GetKey();

		CListBox* pListBox;
		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);

		pListBox->ResetContent();	

		const int nNumKey=attsetKey.GetCount();
		attsetKey.GoHeadPosition();
		for(int i=0; i<nNumKey; i++)
		{
			CAttribute attKey=attsetKey.GetAtt();
			attsetKey++;

			pListBox->AddString(attKey.GetAttName());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);

		pListBox->ResetContent();
		CFDSet fdset=relRelation.GetFDSet();
		const int nNumFD=fdset.GetCount();
		fdset.GoHeadPosition();
		for(int cJ=0; cJ<nNumFD; cJ++)
		{
			CFD fdFD=fdset.GetFD();
			fdset++;

			pListBox->AddString(fdFD.GetstrFD());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);

		pListBox->ResetContent();
		const int nNumPri=relRelation.GetCount();
		relRelation.GoHeadPosition();
		for(int cK=0; cK<nNumPri; cK++)
		{
			CAttributeSet attsetPrimary=relRelation.GetPrimaryKey();
			relRelation++;
			
			pListBox->AddString(attsetPrimary.GetstrAtt());
		}

	pDoc->m_bDraw=FALSE;
	}
	Invalidate(TRUE);
}

void CMainFrame::OnRadio2nf() 
{
	// TODO: Add your control notification handler code here
	CButton* pCheck;
	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_2NF);
	if(pCheck->GetCheck())
	{
		this->OnApp2nf();

		CNormalizationView* pView;
		pView=(CNormalizationView*)this->GetActiveView();
		CNormalizationDoc* pDoc;
		pDoc=pView->GetDocument();

		CComboBox* pComboBox;
		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);

		pComboBox->ResetContent();

		CString strItem;
		int nNumRel=pDoc->m_db2NF.GetCount();
		for(int cI=0; cI<nNumRel; cI++)
		{
			strItem.Format("R%d",cI);
			pComboBox->AddString(strItem);
		}


		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);

		pComboBox->ResetContent();
		
		pComboBox->AddString(pDoc->m_dbRelation.GetRelation().GetRelName());

		nNumRel=pDoc->m_db2NF.GetCount();
		for(cI=0; cI<nNumRel; cI++)
		{
			strItem.Format("R%d",cI);
			pComboBox->AddString(strItem);
		}


		pDoc->m_dbRelation.GoHeadPosition();
		CRelation relRelation=pDoc->m_db2NF.GetRel();	
		CAttributeSet attsetKey=relRelation.GetKey();

		CListBox* pListBox;
		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);

		pListBox->ResetContent();	

		const int nNumKey=attsetKey.GetCount();
		attsetKey.GoHeadPosition();
		for(int i=0; i<nNumKey; i++)
		{
			CAttribute attKey=attsetKey.GetAtt();
			attsetKey++;

			pListBox->AddString(attKey.GetAttName());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);

		pListBox->ResetContent();
		CFDSet fdset=relRelation.GetFDSet();
		const int nNumFD=fdset.GetCount();
		fdset.GoHeadPosition();
		for(int cJ=0; cJ<nNumFD; cJ++)
		{
			CFD fdFD=fdset.GetFD();
			fdset++;

			pListBox->AddString(fdFD.GetstrFD());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);

		pListBox->ResetContent();
		const int nNumPri=relRelation.GetCount();
		relRelation.GoHeadPosition();
		for(int cK=0; cK<nNumPri; cK++)
		{
			CAttributeSet attsetPrimary=relRelation.GetPrimaryKey();
			relRelation++;
			
			pListBox->AddString(attsetPrimary.GetstrAtt());
		}
	pDoc->m_bDraw=FALSE;
	}
	Invalidate(TRUE);
}

void CMainFrame::OnRadio3nf() 
{
	// TODO: Add your control notification handler code here
	CButton* pCheck;
	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_3NF);
	if(pCheck->GetCheck())
	{
		this->OnApp3nf();

		CNormalizationView* pView;
		pView=(CNormalizationView*)this->GetActiveView();
		CNormalizationDoc* pDoc;
		pDoc=pView->GetDocument();

		CComboBox* pComboBox;
		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);

		pComboBox->ResetContent();

		CString strItem;
		int nNumRel=pDoc->m_db3NF.GetCount();
		for(int cI=0; cI<nNumRel; cI++)
		{
			strItem.Format("R%d",cI);
			pComboBox->AddString(strItem);
		}

		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);

		pComboBox->ResetContent();
		
		pComboBox->AddString(pDoc->m_dbRelation.GetRelation().GetRelName());

		nNumRel=pDoc->m_db3NF.GetCount();
		for(cI=0; cI<nNumRel; cI++)
		{
			strItem.Format("R%d",cI);
			pComboBox->AddString(strItem);
		}



		pDoc->m_dbRelation.GoHeadPosition();
		CRelation relRelation=pDoc->m_db3NF.GetRel();	
		CAttributeSet attsetKey=relRelation.GetKey();

		CListBox* pListBox;
		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);

		pListBox->ResetContent();	

		const int nNumKey=attsetKey.GetCount();
		attsetKey.GoHeadPosition();
		for(int i=0; i<nNumKey; i++)
		{
			CAttribute attKey=attsetKey.GetAtt();
			attsetKey++;

			pListBox->AddString(attKey.GetAttName());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);

		pListBox->ResetContent();
		CFDSet fdset=relRelation.GetFDSet();
		const int nNumFD=fdset.GetCount();
		fdset.GoHeadPosition();
		for(int cJ=0; cJ<nNumFD; cJ++)
		{
			CFD fdFD=fdset.GetFD();
			fdset++;

			pListBox->AddString(fdFD.GetstrFD());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);

		pListBox->ResetContent();
		const int nNumPri=relRelation.GetCount();
		relRelation.GoHeadPosition();
		for(int cK=0; cK<nNumPri; cK++)
		{
			CAttributeSet attsetPrimary=relRelation.GetPrimaryKey();
			relRelation++;
			
			pListBox->AddString(attsetPrimary.GetstrAtt());
		}
	pDoc->m_bDraw=FALSE;
	}
	Invalidate(TRUE);
}

void CMainFrame::OnRadio4nf() 
{
	// TODO: Add your control notification handler code here
	CButton* pCheck;
	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_4NF);
	if(pCheck->GetCheck())
	{
		this->OnAppBcnf();

		CNormalizationView* pView;
		pView=(CNormalizationView*)this->GetActiveView();
		CNormalizationDoc* pDoc;
		pDoc=pView->GetDocument();

		CComboBox* pComboBox;
		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);

		pComboBox->ResetContent();

		CString strItem;
		int nNumRel=pDoc->m_dbBCNF.GetCount();
		for(int cI=0; cI<nNumRel; cI++)
		{
			strItem.Format("R%d",cI);
			pComboBox->AddString(strItem);
		}

		pComboBox=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);

		pComboBox->ResetContent();
		
		pComboBox->AddString(pDoc->m_dbRelation.GetRelation().GetRelName());

		nNumRel=pDoc->m_dbBCNF.GetCount();
		for(cI=0; cI<nNumRel; cI++)
		{
			strItem.Format("R%d",cI);
			pComboBox->AddString(strItem);
		}

		pDoc->m_dbRelation.GoHeadPosition();
		CRelation relRelation=pDoc->m_dbBCNF.GetRel();	
		CAttributeSet attsetKey=relRelation.GetKey();

		CListBox* pListBox;
		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);

		pListBox->ResetContent();	

		const int nNumKey=attsetKey.GetCount();
		attsetKey.GoHeadPosition();
		for(int i=0; i<nNumKey; i++)
		{
			CAttribute attKey=attsetKey.GetAtt();
			attsetKey++;

			pListBox->AddString(attKey.GetAttName());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);

		pListBox->ResetContent();
		CFDSet fdset=relRelation.GetFDSet();
		const int nNumFD=fdset.GetCount();
		fdset.GoHeadPosition();
		for(int cJ=0; cJ<nNumFD; cJ++)
		{
			CFD fdFD=fdset.GetFD();
			fdset++;

			pListBox->AddString(fdFD.GetstrFD());
		}

		pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);

		pListBox->ResetContent();
		const int nNumPri=relRelation.GetCount();
		relRelation.GoHeadPosition();
		for(int cK=0; cK<nNumPri; cK++)
		{
			CAttributeSet attsetPrimary=relRelation.GetPrimaryKey();
			relRelation++;
			
			pListBox->AddString(attsetPrimary.GetstrAtt());
		}
	pDoc->m_bDraw=FALSE;
	}
	Invalidate(TRUE);
}

void CMainFrame::OnSelchangeComboOutRel() 
{
	// TODO: Add your control notification handler code here
	CComboBox* pCheckCom;
	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);

	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	CRelation relRelation;
	CAttributeSet attsetKey;

	CButton* pCheck;
	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_1NF);
	if(pCheck->GetCheck())
	{
		relRelation=pDoc->m_rel1NF;	
		attsetKey=relRelation.GetKey();
	}

	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_2NF);
	if(pCheck->GetCheck())
	{
		pDoc->m_db2NF.GoHeadPosition();
		for(int cI=0; cI<pCheckCom->GetCurSel(); cI++)
		{
			pDoc->m_db2NF++;
		}

		relRelation=pDoc->m_db2NF.GetRel();	
		attsetKey=relRelation.GetKey();
	}

	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_3NF);
	if(pCheck->GetCheck())
	{
		pDoc->m_db3NF.GoHeadPosition();
		for(int cI=0; cI<pCheckCom->GetCurSel(); cI++)
		{
			pDoc->m_db3NF++;
		}

		relRelation=pDoc->m_db3NF.GetRel();	
		attsetKey=relRelation.GetKey();
	}

	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_4NF);
	if(pCheck->GetCheck())
	{
		pDoc->m_dbBCNF.GoHeadPosition();
		for(int cI=0; cI<pCheckCom->GetCurSel(); cI++)
		{
			pDoc->m_dbBCNF++;
		}

		relRelation=pDoc->m_dbBCNF.GetRel();	
		attsetKey=relRelation.GetKey();
	}

		
	CListBox* pListBox;
	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);

	pListBox->ResetContent();	

	const int nNumKey=attsetKey.GetCount();
	attsetKey.GoHeadPosition();
	for(int i=0; i<nNumKey; i++)
	{
		CAttribute attKey=attsetKey.GetAtt();
		attsetKey++;

		pListBox->AddString(attKey.GetAttName());
	}

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);

	pListBox->ResetContent();
	CFDSet fdset=relRelation.GetFDSet();
	const int nNumFD=fdset.GetCount();
	fdset.GoHeadPosition();
	for(int cJ=0; cJ<nNumFD; cJ++)
	{
		CFD fdFD=fdset.GetFD();
		fdset++;

		pListBox->AddString(fdFD.GetstrFD());
	}

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);

	pListBox->ResetContent();
	const int nNumPri=relRelation.GetCount();
	relRelation.GoHeadPosition();
	for(int cK=0; cK<nNumPri; cK++)
	{
		CAttributeSet attsetPrimary=relRelation.GetPrimaryKey();
		relRelation++;
			
		pListBox->AddString(attsetPrimary.GetstrAtt());
	}
}

void CMainFrame::OnAppAttribute() 
{
	// TODO: Add your command handler code here
	CString strTemp;
	CAttributeSet attsetTemp;

	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	pDoc->m_bEdit=TRUE;

	CMakeRelDlg *pDlg=new CMakeRelDlg;
	pDlg->DoModal();
	delete pDlg;

	pDoc->m_bEdit=FALSE;
	
	CRelation relRelation=pDoc->m_dbRelation.GetRelation();
	CAttributeSet attsetKey=relRelation.GetKey();

	strTemp=pDoc->m_dbRelation.GetstrRel();

	CListBox* pListBox;
	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_IN_ATT);
	
	pListBox->ResetContent();	

	const int nNumKey=attsetKey.GetCount();
	attsetKey.GoHeadPosition();
	for(int i=0; i<nNumKey; i++)
	{
		CAttribute attKey=attsetKey.GetAtt();
		attsetKey++;

		pListBox->AddString(attKey.GetAttName());
	}

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_IN_FD);

	pListBox->ResetContent();
	CFDSet fdset=relRelation.GetFDSet();
	const int nNumFD=fdset.GetCount();
	fdset.GoHeadPosition();
	for(int cJ=0; cJ<nNumFD; cJ++)
	{
		CFD fdFD=fdset.GetFD();
		fdset++;

		pListBox->AddString(fdFD.GetstrFD());
	}

	CComboBox* pCheckCom;
	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_REL);
	pCheckCom->ResetContent();

	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);
	pCheckCom->ResetContent();
	
	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_ATT);
	pListBox->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_PRI);
	pListBox->ResetContent();

	pListBox=(CListBox*)m_wndDialogBar.GetDlgItem(IDC_LIST_OUT_FD);
	pListBox->ResetContent();

	pDoc->m_bDraw=FALSE;
	Invalidate(TRUE);
}

void CMainFrame::OnSelchangeComboOutDiagram() 
{
	// TODO: Add your control notification handler code here

	CComboBox* pCheckCom;
	pCheckCom=(CComboBox*)m_wndDialogBar.GetDlgItem(IDC_COMBO_OUT_DIAGRAM);

	CNormalizationView* pView;
	pView=(CNormalizationView*)this->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	CRelation relRelation;
	CAttributeSet attsetKey;

	CButton* pCheck;
	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_1NF);
	if(pCheck->GetCheck())
	{
		relRelation=pDoc->m_rel1NF;	
	}

	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_2NF);
	if(pCheck->GetCheck())
	{
		pDoc->m_db2NF.GoHeadPosition();
		for(int cI=0; cI<pCheckCom->GetCurSel()-1; cI++)
		{
			pDoc->m_db2NF++;
		}

		relRelation=pDoc->m_db2NF.GetRel();	
	}

	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_3NF);
	if(pCheck->GetCheck())
	{
		pDoc->m_db3NF.GoHeadPosition();
		for(int cI=0; cI<pCheckCom->GetCurSel()-1; cI++)
		{
			pDoc->m_db3NF++;
		}

		relRelation=pDoc->m_db3NF.GetRel();	
	}

	pCheck=(CButton*)m_wndDialogBar.GetDlgItem(IDC_RADIO_4NF);
	if(pCheck->GetCheck())
	{
		pDoc->m_dbBCNF.GoHeadPosition();
		for(int cI=0; cI<pCheckCom->GetCurSel()-1; cI++)
		{
			pDoc->m_dbBCNF++;
		}

		relRelation=pDoc->m_dbBCNF.GetRel();	
	}

	if(pCheckCom->GetCurSel()==0)
	{
		pDoc->m_relDraw=pDoc->m_dbRelation.GetRelation();
		pDoc->m_bDraw=TRUE;
	}
	else
	{
		pDoc->m_relDraw=relRelation;
		pDoc->m_bDraw=TRUE;
	}
		pDoc->m_relDraw.SetFDSet(pDoc->m_relDraw.GetFDSet().CanonicalCover());

	Invalidate(TRUE);
}
