// MakeRelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Normalization.h"
#include "MakeRelDlg.h"

#include "MainFrm.h"
#include "NormalizationDoc.h"
#include "NormalizationView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMakeRelDlg dialog


CMakeRelDlg::CMakeRelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMakeRelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMakeRelDlg)
	m_strOutRel = _T("");
	m_strInAtt = _T("");
	m_strInRel = _T("");
	//}}AFX_DATA_INIT
}


void CMakeRelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMakeRelDlg)
	DDX_Control(pDX, IDC_ATTLIST, m_listBoxAtt);
	DDX_Text(pDX, IDC_OUTRELEDIT, m_strOutRel);
	DDX_Text(pDX, IDC_INATTEDIT, m_strInAtt);
	DDX_Text(pDX, IDC_INRELEDIT, m_strInRel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMakeRelDlg, CDialog)
	//{{AFX_MSG_MAP(CMakeRelDlg)
	ON_BN_CLICKED(IDC_INATTOK, OnInattok)
	ON_BN_CLICKED(IDC_INRELOK, OnInrelok)
	ON_BN_CLICKED(IDC_DELATTOK, OnDelattok)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMakeRelDlg message handlers

// attribute Է 
void CMakeRelDlg::OnInattok() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if(m_strInAtt.IsEmpty()!=TRUE)			// Է  ְ,
		if(m_strInAtt.GetAt(0)!=' ')		// ó space ƴϰ
			if(m_listBoxAtt.FindString(0, m_strInAtt)==LB_ERR)	// ߺԷ ƴҰ
				m_listBoxAtt.AddString(m_strInAtt);	// Է ޴´.

	m_strInAtt.Empty();
	UpdateData(FALSE);
}

// relation name Է 
void CMakeRelDlg::OnInrelok() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if(m_strInRel.IsEmpty()!=TRUE)		// Է  ְ,
		if(m_strInRel.GetAt(0)!=' ')	// ó space ƴ 
			m_strOutRel="Name : "+m_strInRel;	// Է ޴´.

	m_strInRel.Empty();
	UpdateData(FALSE);
}

void CMakeRelDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CMakeRelDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	// main document Ѵ.
	CMainFrame* pFrame;
	pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	CNormalizationView* pView;
	pView=(CNormalizationView*)pFrame->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	const int nSizeAttSet=m_listBoxAtt.GetCount();
	CAttributeSet attsetTemp;
	CString strAtt;

	// key list ̴´.
	for(int i=0; i<nSizeAttSet; i++)
	{
		m_listBoxAtt.GetText(i, strAtt);
		attsetTemp+=(CAttribute)strAtt;
	}

	if(m_strOutRel.IsEmpty()==FALSE)	// relation name ְ,
	{
		if(attsetTemp.GetCount()!=0)	// key  
		{
			m_strOutRel.Delete(0, 7);	// "Name : " Ѵ.
			m_relRelation.SetRelName(m_strOutRel);
			m_relRelation.SetKey(attsetTemp);
			pDoc->m_dbRelation.SetRelation(m_relRelation);

			pDoc->m_b1NF=FALSE;
			pDoc->m_b2NF=FALSE;
			pDoc->m_b3NF=FALSE;
			pDoc->m_bBCNF=FALSE;
		}
	}

	CDialog::OnOK();
}

void CMakeRelDlg::OnDelattok() 
{
	// TODO: Add your control notification handler code here
	CString strTemp;

	int nSizeAtt=m_listBoxAtt.GetCount();

	for(int i=0; i<nSizeAtt; i++)
	{
		if(m_listBoxAtt.GetSel(i)>0)
		{
			CString strAtt;
			m_listBoxAtt.GetText(i, strAtt);
			
			m_listBoxAtt.DeleteString(i);
			i--;
			nSizeAtt--;
		}
	}
	
}

BOOL CMakeRelDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	// main document Ѵ.
	CMainFrame* pFrame;
	pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	CNormalizationView* pView;
	pView=(CNormalizationView*)pFrame->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	if(pDoc->m_bEdit==TRUE)
	{
		CRelation relRelation=pDoc->m_dbRelation.GetRelation();
		m_strOutRel="Name : "+relRelation.GetRelName();
		
		CAttributeSet attsetKey=relRelation.GetKey();
		int nNumKey=attsetKey.GetCount();

		attsetKey.GoHeadPosition();
		for(int cI=0; cI<nNumKey; cI++)
		{
			CAttribute attKey=attsetKey.GetAtt();
			attsetKey++;
			
			m_listBoxAtt.AddString(attKey.GetAttName());
		}
	}

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

