// OutputDlg.cpp : implementation file
//

#include "stdafx.h"
#include "normalization.h"
#include "OutputDlg.h"

#include "MainFrm.h"
#include "NormalizationDoc.h"
#include "NormalizationView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutputDlg dialog



COutputDlg::COutputDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COutputDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COutputDlg)
	m_strRelName = _T("");
	//}}AFX_DATA_INIT
}


void COutputDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COutputDlg)
	DDX_Control(pDX, IDC_LISTPRIMARY, m_listBoxPrimary);
	DDX_Control(pDX, IDC_RELTAB, m_ctrlTabRel);
	DDX_Control(pDX, IDC_LISTFD, m_listBoxFD);
	DDX_Control(pDX, IDC_LISTATT, m_listBoxAtt);
	DDX_Text(pDX, IDC_RELNAME, m_strRelName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COutputDlg, CDialog)
	//{{AFX_MSG_MAP(COutputDlg)
	ON_BN_CLICKED(IDC_OUTPUTEXIT, OnOutputexit)
	ON_NOTIFY(TCN_SELCHANGE, IDC_RELTAB, OnSelchangeReltab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputDlg message handlers

/*
BOOL COutputDlg::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::Create(IDD, pParentWnd);
}
*/

BOOL COutputDlg::Create(CWnd *pParentWnd)
{
	return CDialog::Create(IDD, pParentWnd);
}

BOOL COutputDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CString strTemp;

	CMainFrame* pFrame;
	pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	CNormalizationView* pView;
	pView=(CNormalizationView*)pFrame->GetActiveView();
	CNormalizationDoc* pDoc;
	pDoc=pView->GetDocument();

	CRelation relTemp;

	COutputDlg* pDlg=NULL;

	switch(pDoc->m_nSel)
	{
		case 1:
			relTemp=pDoc->m_rel1NF;
			m_dbNormalForm.AddRel(relTemp);
			break;
		case 2:
			m_dbNormalForm=pDoc->m_db2NF;
			break;
		case 3:
			m_dbNormalForm=pDoc->m_db3NF;
			break;
		case 4:
			m_dbNormalForm=pDoc->m_dbBCNF;
			break;
		default:
			break;
	}

	const int nSizeDB=m_dbNormalForm.GetCount();
	for(int i=0; i<nSizeDB; i++)
	{
		CString strItem;
		strItem.Format("R%d", i);
		m_ctrlTabRel.InsertItem(i, strItem);
	}

	m_dbNormalForm.GoHeadPosition();

	this->Output(m_dbNormalForm.GetRel());

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL COutputDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::DestroyWindow();
}

void COutputDlg::Output(CRelation relInput)
{
	CString strTemp;

	m_listBoxAtt.ResetContent();
	m_listBoxFD.ResetContent();
	m_listBoxPrimary.ResetContent();

	CAttributeSet attsetKey=relInput.GetKey();
	CFDSet fdset=relInput.GetFDSet();

	strTemp=attsetKey.GetstrAtt();
	strTemp=fdset.GetstrFD();

	const int nSizeAttSet=attsetKey.GetCount();
	const int nSizeFDSet=fdset.GetCount();

	relInput.GoHeadPosition();
	const int nSizePrimarySet=relInput.GetCount();
	for(int i=0; i<nSizePrimarySet; i++)
	{
		CAttributeSet attsetPrimaryKey=relInput.GetPrimaryKey();
		relInput++;

		strTemp=attsetPrimaryKey.GetstrAtt();

		strTemp.Empty();
		int nSizePrimary=attsetPrimaryKey.GetCount();
		attsetPrimaryKey.GoHeadPosition();
		for(int j=0; j<nSizePrimary; j++)
		{
			CAttribute attPrimaryKey=attsetPrimaryKey.GetAtt();
			attsetPrimaryKey++;

			strTemp+=attPrimaryKey.GetAttName()+", ";
		}
		strTemp.Delete(strTemp.GetLength()-2, 2);
		m_listBoxPrimary.AddString(strTemp);
	}

	attsetKey.GoHeadPosition();
	for(i=0; i<nSizeAttSet; i++)
	{
		CAttribute attKey=attsetKey.GetAtt();
		attsetKey++;

		strTemp=attKey.GetAttName();

		m_listBoxAtt.AddString(strTemp);
	}

	fdset.GoHeadPosition();
	for(i=0; i<nSizeFDSet; i++)
	{
		CFD fdFD=fdset.GetFD();
		fdset++;

		strTemp=fdFD.GetstrFD();

		m_listBoxFD.AddString(fdFD.GetstrFD());
	}
	
}

void COutputDlg::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CMainFrame* pFrame;
	pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	pFrame->m_pDlg=NULL;
	delete this;

	CDialog::PostNcDestroy();
}

void COutputDlg::OnOutputexit() 
{
	// TODO: Add your control notification handler code here

	DestroyWindow();
}


void COutputDlg::OnSelchangeReltab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	const int nTabNum=m_ctrlTabRel.GetCurSel();	// õ tab number
	if(nTabNum>=0)
	{
		m_dbNormalForm.GoHeadPosition();
		for(int i=0; i<nTabNum; i++)	// õ tab relation ã´.
		{
			m_dbNormalForm++;
		}
		this->Output(m_dbNormalForm.GetRel());
	}
	
	*pResult = 0;
}
