// Relation.cpp: implementation of the CRelation class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Normalization.h"
#include "Relation.h"
#include "DataBase.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRelation::CRelation()
{
	m_nIndex=0;
	m_rPosition=NULL;
}

CRelation::CRelation(CRelation& relInput)
{
	*this=relInput;
}

CRelation::~CRelation()
{

}

int CRelation::GetCount()
{
	return m_PrimaryList.GetCount();
}

CString CRelation::GetRelName()
{
	return m_strRelName;
}

CAttributeSet CRelation::GetKey()
{
	return m_attsetKey;
}


CAttributeSet CRelation::GetPrimaryKey()
{
	return m_PrimaryList.GetAt(m_rPosition);
}

CFDSet CRelation::GetFDSet()
{
	return m_fdset;
}

void CRelation::SetRelName(CString strInput)
{
	m_strRelName=strInput;
}

void CRelation::SetKey(CAttributeSet attsetInput)
{
	m_attsetKey=attsetInput;
}

void CRelation::SetFDSet(CFDSet fdsetInput)
{
	m_fdset=fdsetInput;
}

void CRelation::GoHeadPosition()
{
	m_nIndex=0;
	m_rPosition=m_PrimaryList.GetHeadPosition();
}

CAttributeSet CRelation::Closure(CAttributeSet attsetInput)
{
	CAttributeSet attsetClosure;
	BOOL bChange;
	CFD fdTemp1;

	attsetClosure=attsetInput;

	while(1)
	{
		bChange=FALSE;

		m_fdset.GoHeadPosition();
		for(int i=0; i<m_fdset.GetCount(); i++)
		{
			fdTemp1=m_fdset.GetFD();
			m_fdset++;
			if(attsetClosure.IsMemberOf(fdTemp1.GetLHS())==TRUE)
			{
				if(attsetClosure.IsMemberOf(fdTemp1.GetRHS())==FALSE)
				{
					attsetClosure+=fdTemp1.GetRHS();
					bChange=TRUE;
				}
			}
		}
		if(bChange==FALSE)
			break;
	}
	return attsetClosure;
}

CAttributeSet CRelation::FindKey()
{
	CAttributeSet attsetKey=m_attsetKey;
	CAttribute attX;
	const int nLenOfAttList=m_attsetKey.GetCount();

	m_attsetKey.GoHeadPosition();
	for(int i=0; i<nLenOfAttList; i++)
	{
		attX=m_attsetKey.GetAtt();
		attsetKey.DelAtt(attX);
		if(attsetKey.Closure(m_fdset)!=m_attsetKey)
			attsetKey.AddAtt(attX);

	}

	return attsetKey;
}

void CRelation::FindPrimaryKey()
{
	if(m_attsetKey.GetCount()==0)
		return;

	int i, j;
	CString strTemp;
	CAttribute attTemp1;
	CAttributeSet attsetTemp1;
	CAttributeSet attsetTemp2;
	CAttributeSet attsetTemp3;
	CFD fdTemp1;
	CFD fdTemp2;
	CFDSet fdsetTemp1;
	CFDSet fdsetTemp2;

	m_PrimaryList.RemoveAll();

	// FD  attribute set
	CAttributeSet attsetNoFDKey=m_attsetKey-m_fdset.GetCover();

	// attribute ߿ determinant ͸  set
	attsetTemp1=m_fdset.GetDeterminant();

	if(attsetTemp1.GetCount()==0)
	{
		m_PrimaryList.AddTail(attsetNoFDKey);
		return;
	}

	strTemp=attsetTemp1.GetstrAtt();

	attsetTemp1.GoHeadPosition();
	for(i=0; i<attsetTemp1.GetCount(); i++)
	{
		fdTemp1.SetLHS((CAttributeSet)attsetTemp1.GetAtt());
		attsetTemp1++;

		fdsetTemp1+=fdTemp1;
	}

	strTemp=fdsetTemp1.GetstrFD();

	while(1)
	{
		fdsetTemp2.Empty();

		// closure Ѵ.
		fdsetTemp1.GoHeadPosition();
		for(i=0; i<fdsetTemp1.GetCount(); i++)
		{
			fdTemp1=fdsetTemp1.GetFD();
			fdsetTemp1++;

			strTemp=fdTemp1.GetstrFD();

			attsetTemp3=fdTemp1.GetLHS();
			if(fdTemp1.GetRHS().IsMemberOf(attsetTemp3)==FALSE)
			{
				fdTemp1.SetRHS(Closure(attsetTemp3));
				fdsetTemp2+=fdTemp1;
			}

			strTemp=fdsetTemp2.GetstrFD();
		}

		// test
		fdsetTemp2.GoHeadPosition();
		for(i=0; i<fdsetTemp2.GetCount(); i++)
		{
			fdTemp1=fdsetTemp2.GetFD();
			fdsetTemp2++;

			strTemp=fdTemp1.GetstrFD();

			if(fdTemp1.GetRHS()==m_attsetKey-attsetNoFDKey)
			{
				m_PrimaryList.AddTail(fdTemp1.GetLHS()+attsetNoFDKey);
			}
		}

		if(m_PrimaryList.GetCount()!=0)
		{
			GoHeadPosition();
			return;
		}

		fdsetTemp2.GoHeadPosition();

		fdsetTemp1.Empty();
		BOOL bTemp1=FALSE;
		int l, m;
		for(i=0; i<fdsetTemp2.GetCount()-1; i++)
		{
			fdTemp1=fdsetTemp2.GetFD();
			fdsetTemp2++;

			attsetTemp2=attsetTemp1-fdTemp1.GetLHS();

			if(attsetTemp2.GetCount()<i)
			{
				if(bTemp1==FALSE)
				{
					bTemp1=TRUE;
					j=1;
					l=1;
					m=1;
				}
				else
				{
					m++;
					j=m;
					if(j>attsetTemp2.GetCount())
					{
						m=l+1;
						j=m;
						l++;
					}
				}
			}
			else
				j=i;
			attsetTemp2.GoIndex(j);
			for(; j<attsetTemp2.GetCount(); j++)
			{
				fdTemp2=fdTemp1;
				attTemp1=attsetTemp2.GetAtt();
				attsetTemp2++;
				fdTemp2.AddLHS((CAttributeSet)attTemp1);
				attTemp1.Empty();
				fdTemp2.SetRHS(attTemp1);
//				fdTemp2.SetRHS((CAttributeSet)(CAttribute)(CString)"");
				fdsetTemp1.AddFD(fdTemp2, TRUE);
			}
		}
	}
}

CRelation CRelation::Find1NF()
{
	CFDSet fdsetTemp;
	CRelation rel1NF;

	// key .
	rel1NF.SetKey(m_attsetKey);

	const int nSizeFDSet=m_fdset.GetCount();
	m_fdset.GoHeadPosition();
	for(int cI=0; cI<nSizeFDSet; cI++)
	{
		CFD fdFD=m_fdset.GetFD();
		m_fdset++;

		fdFD.SetRHS(fdFD.GetLHS().Closure(m_fdset));
		fdsetTemp+=fdFD;
	}

	// FDSet CanonoicalCover Ѵ.
	fdsetTemp=fdsetTemp.CanonicalCover();
	fdsetTemp=fdsetTemp.DelRedundant();
	rel1NF.SetFDSet(fdsetTemp);

	// Primary Key Ѵ.
	rel1NF.FindPrimaryKey();

	CString strTemp;
	strTemp=rel1NF.GetstrRel();

	return rel1NF;
}

CDataBase CRelation::Find2NF()
{
	CRelation rel1NF(this->Find1NF());
	return this->Find2NF(rel1NF);
}

CDataBase CRelation::Find2NF(CRelation rel1NF)
{
	CString strTemp;

	strTemp=rel1NF.GetstrRel();

	rel1NF.GoHeadPosition();
	CAttributeSet attsetKey=rel1NF.GetKey();
	CAttributeSet attsetPrimaryKey=rel1NF.GetPrimaryKey();;
	CAttributeSet attsetNonKey=attsetKey-attsetPrimaryKey;
	CFDSet fdsetFD=rel1NF.GetFDSet();

	CDataBase dbS;
	CRelation relUi;

	// primarykey  subset Ѵ.
	const int nSizeSubSet=(int)pow(2, attsetPrimaryKey.GetCount());
	for(int cI=1; cI<nSizeSubSet; cI++)
	{
		// primarykey subset Ѵ.
		CAttributeSet attsetSubSet=attsetPrimaryKey.GetSubSet(cI);

		strTemp=attsetSubSet.GetstrAtt();

		// primarykey subset closure Ѵ.
		CAttributeSet attsetClosure=attsetSubSet.Closure(fdsetFD);

		strTemp=attsetSubSet.GetstrAtt();

		// primarykey set  closure fd  primarykey
		// ԽŲ.
		if(cI==nSizeSubSet-1)
		{
			// FD  attribute set
			CAttributeSet attsetNoFDKey=m_attsetKey-m_fdset.GetCover();
		
			CFDSet fdset=fdsetFD.DelUesless(attsetClosure);

			strTemp=fdset.GetstrFD();

			relUi.SetKey(attsetClosure+attsetNoFDKey);
			relUi.SetFDSet(fdset);

			strTemp=relUi.GetstrRel();
				
			relUi.FindPrimaryKey();

			strTemp=relUi.GetstrRel();

			dbS.AddRel(relUi);
		}
		else
			// primarykey subset X nonkey Y fd  
			// 2NF decompostionѴ.
			if((attsetClosure-attsetPrimaryKey).GetCount()>0)
	//		if(attsetNonKey.IsMemberOf(attsetClosure))
	//		if(attsetClosure!=attsetSubSet)
			{
				// subset X determinant fd ã´.
				CFDSet fdset=fdsetFD.DelUesless(attsetClosure);

	//			CFDSet fdset=fdsetTemp.DelUesless(attsetClosure);
	//			CFDSet fdset=fdsetFD.DelRedundant(attsetSubSet);

				strTemp=fdset.GetstrFD();

				relUi.SetKey(attsetClosure);
				relUi.SetFDSet(fdset);

				strTemp=relUi.GetstrRel();
				
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrRel();

				dbS.AddRel(relUi);

				attsetKey=attsetKey-(attsetClosure-attsetSubSet);

				strTemp=attsetKey.GetstrAtt();

				fdsetFD=fdsetFD.DelUesless(attsetKey);

				strTemp=fdsetFD.GetstrFD();
			}
	}

	return dbS;

	/*
	CAttributeSet attsetSubSet;
	CAttributeSet attsetPrimaryKey;
	CAttributeSet attsetKey=rel1NF.GetKey();
	CFDSet fdsetTemp=rel1NF.GetFDSet();

	CDataBase dbS;
	CRelation relUi;

	int nSizeAttSet=rel1NF.GetCount();

	rel1NF.GoHeadPosition();
	for(int i=0; i<nSizeAttSet; i++)
	{
		attsetPrimaryKey=rel1NF.GetPrimaryKey();

		strTemp=fdsetTemp.GetstrFD();

		strTemp=attsetPrimaryKey.GetstrAtt();

		rel1NF++;



//		int nSizeSubSet=(int)pow(2, attsetPrimaryKey.GetCount());
		int nSizeSubSet=(int)pow(2, attsetKey.GetCount());
		for(int j=1; j<nSizeSubSet; j++)
		{
			/*
			// primarykey subset Ѵ.
			attsetSubSet=attsetPrimaryKey.GetSubSet(j, attsetPrimaryKey.GetCount());

			strTemp=attsetSubSet.GetstrAtt();

			// primarykey subset closure Ѵ.
			CAttributeSet attsetClosure=attsetSubSet.Closure(fdsetTemp);
			*//*

			attsetSubSet=attsetKey.GetSubSet(j, attsetKey.GetCount());
			strTemp=attsetSubSet.GetstrAtt();

			if(attsetSubSet.GetCount()==0)
				continue;
			if((attsetKey-attsetPrimaryKey).IsMemberOf(attsetSubSet))
				continue;

			strTemp=attsetSubSet.GetstrAtt();

			CAttributeSet attsetClosure=attsetSubSet.Closure(fdsetTemp);

			strTemp=attsetClosure.GetstrAtt();

			if(attsetClosure!=attsetSubSet)
			{
				CFDSet fdset=fdsetTemp.DelUesless(attsetClosure);

				//CFDSet fdset=fdsetTemp.DelRedundant(attsetSubSet);

				strTemp=fdset.GetstrFD();

				relUi.SetKey(attsetClosure);
				relUi.SetFDSet(fdset);

				strTemp=relUi.GetstrRel();
				
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrRel();

				dbS.AddRel(relUi);

				attsetKey=attsetKey-(attsetClosure-attsetSubSet);

				strTemp=attsetKey.GetstrAtt();

				fdsetTemp=fdsetTemp.DelUesless(attsetKey);

//				fdsetTemp=fdsetTemp-fdset;

				strTemp=fdsetTemp.GetstrFD();
			}
		}
	}

	return dbS;
*/	
}

CDataBase CRelation::Find3NF()
{
	CDataBase db2NF(this->Find2NF());
	return this->Find3NF(db2NF);
}


CDataBase CRelation::Find3NF(CDataBase db2NF)
{
	CString strTemp;

	strTemp=db2NF.GetstrRel();

	CAttributeSet attsetSubSet;
	CAttributeSet attsetPrimaryKey;

	CDataBase dbS;
	CRelation relUi;
	CRelation relXi;
	while(1)
	{
		int nSizeRelSet=db2NF.GetCount();

		// db2nf  relation ؼ 3NF ã´.
		db2NF.GoHeadPosition();
		for(int k=0; k<nSizeRelSet; k++)
		{
			relXi=db2NF.GetRel();
			db2NF++;

			relXi.GoHeadPosition();
			CAttributeSet attsetKey=relXi.GetKey();
			CAttributeSet attsetPrimaryKey=relXi.GetPrimaryKey();
			CFDSet fdsetFD=relXi.GetFDSet();

			strTemp=fdsetFD.GetstrFD();

			CAttributeSet attsetNonKey=attsetKey-attsetPrimaryKey;

			strTemp=attsetNonKey.GetstrAtt();

			//  nonkey subset ؼ
			int nSizeSubSet=(int)pow(2, attsetNonKey.GetCount());
			if(nSizeSubSet==1)
			{
				strTemp=relXi.GetstrRel();

				dbS.AddRel(relXi);
			}
			for(int j=1; j<nSizeSubSet; j++)
			{
				// Nonkey subset Ѵ.
				attsetSubSet=attsetNonKey.GetSubSet(j);

				strTemp=attsetSubSet.GetstrAtt();

				// Nonkey subset closure Ѵ.
				CAttributeSet attsetClosure=attsetSubSet.Closure(fdsetFD);

				strTemp=attsetClosure.GetstrAtt();

				// closure primary key .
				attsetClosure=attsetClosure-attsetPrimaryKey;

				strTemp=attsetPrimaryKey.GetstrAtt();

				strTemp=attsetClosure.GetstrAtt();

				if(attsetClosure!=attsetSubSet)
				{
					CFDSet fdset=fdsetFD.DelUesless(attsetClosure);

					strTemp=fdset.GetstrFD();

					if(fdset.GetCount()!=0)
					{
						relUi.SetKey(attsetClosure);
						relUi.SetFDSet(fdset.MinumumCover().CanonicalCover());

						strTemp=relUi.GetstrRel();
				
						relUi.FindPrimaryKey();

						strTemp=relUi.GetstrRel();

						dbS.AddRel(relUi);

						attsetKey=attsetKey-(attsetClosure-attsetSubSet);

						strTemp=attsetKey.GetstrAtt();

						fdsetFD=fdsetFD.DelUesless(attsetKey);

						strTemp=fdsetFD.GetstrFD();

	//					fdsetTemp=fdsetTemp-fdset;
					}
				}
			}

			if(fdsetFD.GetCover().GetCount()!=0)
			{
				relUi.SetKey(fdsetFD.GetCover());
				relUi.SetFDSet(fdsetFD.MinumumCover().CanonicalCover());

				strTemp=relUi.GetstrRel();
				
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrRel();

				dbS.AddRel(relUi);
			}
		}
		if(dbS.GetCount()==nSizeRelSet)
			break;
		else
		{
			db2NF=dbS;
			dbS.Empty();
		}
	}

	return dbS;



/*
	CString strTemp;

	strTemp=db2NF.GetstrRel();

	CAttributeSet attsetSubSet;
	CAttributeSet attsetPrimaryKey;

	CDataBase dbS;
	CRelation relUi;
	CRelation relXi;

	int nSizeRelSet=db2NF.GetCount();
	db2NF.GoHeadPosition();
	for(int k=0; k<nSizeRelSet; k++)
	{
		relXi=db2NF.GetRel();
		db2NF++;

		CAttributeSet attsetKey=relXi.GetKey();
		CFDSet fdsetTemp=relXi.GetFDSet();

		strTemp=fdsetTemp.GetstrFD();

		int nSizeAttSet=relXi.GetCount();

		relXi.GoHeadPosition();
		for(int i=0; i<nSizeAttSet; i++)
		{
//			fdsetTemp=rel1NF.GetFDSet();
			attsetPrimaryKey=relXi.GetPrimaryKey();
			relXi++;

			CAttributeSet attsetNonKey=attsetKey-attsetPrimaryKey;
//			CAttributeSet attsetNonKey=attsetKey;

			strTemp=attsetNonKey.GetstrAtt();

			int nSizeSubSet=(int)pow(2, attsetNonKey.GetCount());
			for(int j=1; j<nSizeSubSet; j++)
			{
				// Nonkey subset Ѵ.
				attsetSubSet=attsetNonKey.GetSubSet(j, attsetNonKey.GetCount());
//				if(attsetPrimaryKey.IsMemberOf(attsetSubSet))
//					continue;

				strTemp=attsetSubSet.GetstrAtt();

				// Nonkey subset closure Ѵ.
				CAttributeSet attsetClosure=attsetSubSet.Closure(fdsetTemp);

				strTemp=attsetClosure.GetstrAtt();

				attsetClosure=attsetClosure-attsetPrimaryKey;

				strTemp=attsetPrimaryKey.GetstrAtt();

				strTemp=attsetClosure.GetstrAtt();

				if(attsetClosure!=attsetSubSet)
				{
					CFDSet fdset=fdsetTemp.DelUesless(attsetClosure);

					//CFDSet fdset=fdsetTemp.DelRedundant(attsetSubSet);

					strTemp=fdset.GetstrFD();

					if(fdset.GetCount()!=0)
					{
						relUi.SetKey(attsetClosure);
						relUi.SetFDSet(fdset);

						strTemp=relUi.GetstrRel();
				
						relUi.FindPrimaryKey();

						strTemp=relUi.GetstrRel();

						dbS.AddRel(relUi);

						attsetKey=attsetKey-(attsetClosure-attsetSubSet);

						strTemp=attsetKey.GetstrAtt();

						fdsetTemp=fdsetTemp.DelUesless(attsetKey);

						strTemp=fdsetTemp.GetstrFD();

//					fdsetTemp=fdsetTemp-fdset;
					}
				}
			}

			if(fdsetTemp.GetCover().GetCount()!=0)
			{
				relUi.SetKey(fdsetTemp.GetCover());
				relUi.SetFDSet(fdsetTemp);

				strTemp=relUi.GetstrRel();
				
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrRel();

				dbS.AddRel(relUi);
			}
		}
	}

	return dbS;
	*/
}

CDataBase CRelation::FindBCNF()
{
	CDataBase db3NF(this->Find3NF());
	return this->FindBCNF(db3NF);
}

CDataBase CRelation::FindBCNF(CDataBase db3NF)
{
	CString strTemp;

	strTemp=db3NF.GetstrRel();

	CAttributeSet attsetSubSet;
	CAttributeSet attsetPrimaryKey;

	CDataBase dbS;
	CRelation relUi;
	CRelation relXi;


	int nSizeRelSet=db3NF.GetCount();
	db3NF.GoHeadPosition();
	for(int k=0; k<nSizeRelSet; k++)
	{
		relXi=db3NF.GetRel();
		db3NF++;

		CAttributeSet attsetKey=relXi.GetKey();
		CFDSet fdsetTemp=relXi.GetFDSet();

		strTemp=fdsetTemp.GetstrFD();

		int nSizeAttSet=relXi.GetCount();

		relXi.GoHeadPosition();
		for(int i=0; i<nSizeAttSet; i++)
		{
			attsetPrimaryKey=relXi.GetPrimaryKey();
			relXi++;

			CAttributeSet attsetNonKey=attsetKey-attsetPrimaryKey;

			strTemp=attsetNonKey.GetstrAtt();

			int nSizeSubSet=(int)pow(2, attsetNonKey.GetCount());
			for(int j=1; j<nSizeSubSet; j++)
			{
				// Nonkey subset Ѵ.
				attsetSubSet=attsetNonKey.GetSubSet(j, attsetNonKey.GetCount());

				strTemp=attsetSubSet.GetstrAtt();

				// Nonkey subset closure Ѵ.
				CAttributeSet attsetClosure=attsetSubSet.Closure(fdsetTemp);

				strTemp=attsetClosure.GetstrAtt();

				if(attsetClosure!=attsetSubSet)
				{
					CFDSet fdset=fdsetTemp.DelUesless(attsetClosure);

					//CFDSet fdset=fdsetTemp.DelRedundant(attsetSubSet);

					strTemp=fdset.GetstrFD();

					if(fdset.GetCount()!=0)
					{
						relUi.SetKey(attsetClosure);
						relUi.SetFDSet(fdset.MinumumCover().CanonicalCover());

						strTemp=relUi.GetstrRel();
				
						relUi.FindPrimaryKey();
						
						strTemp=relUi.GetstrRel();

						dbS.AddRel(relUi);

						attsetKey=attsetKey-(attsetClosure-attsetSubSet);

						strTemp=attsetKey.GetstrAtt();

						fdsetTemp=fdsetTemp.DelUesless(attsetKey);

						strTemp=fdsetTemp.GetstrFD();

//					fdsetTemp=fdsetTemp-fdset;
					}
				}
			}

			if(attsetKey.GetCount()>1)
//			if(fdsetTemp.GetAttSet().GetCount()!=0)
			{
				relUi.SetKey(attsetKey);
//				relUi.SetKey(fdsetTemp.GetAttSet());
				relUi.SetFDSet(fdsetTemp.MinumumCover().CanonicalCover());

				strTemp=relUi.GetstrRel();
				
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrRel();

				dbS.AddRel(relUi);
			}
		}
	}
/*
	while(1)
	{
		BOOL bChange=FALSE;
		int nNumRel=dbS.GetCount();
		dbS.GoHeadPosition();
		for(int cI=0; cI<nNumRel; cI++)
		{
			CRelation relRelation=dbS.GetRel();
			dbS++;

			strTemp=relRelation.GetstrRel();

			if(relRelation.GetCount()<2)
				continue;

			CFDSet fdset=relRelation.GetFDSet();
			CAttributeSet attsetKey=relRelation.GetKey();
			int nNumPrimary=relRelation.GetCount();

			relRelation.GoHeadPosition();
			for(int cJ=0; cJ<nNumPrimary; cJ++)
			{
				CAttributeSet attsetPrimary=relRelation.GetPrimaryKey();
				relRelation++;

				CAttributeSet attsetClosure;
				attsetClosure=attsetPrimary.Closure(fdset);
	
				strTemp=attsetClosure.GetstrAtt();

				CRelation relUi;
				relUi.SetKey(attsetClosure);
				relUi.SetFDSet(fdset.DelRedundant(attsetPrimary).MinumumCover());
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrFD();

				dbS.AddRel(relUi);
				bChange=TRUE;
			}
			if(bChange==TRUE)
			{
				strTemp=dbS.GetstrRel();

				dbS.DelRel(relRelation);
			
				strTemp=dbS.GetstrRel();
				
				break;
			}
		}
		if(bChange==FALSE)
			break;
	}
*/
	while(1)
	{
		BOOL bChange=FALSE;
		int nNumRel=dbS.GetCount();
		dbS.GoHeadPosition();
		for(int cI=0; cI<nNumRel; cI++)
		{
			CRelation relRelation=dbS.GetRel();
			dbS++;

			strTemp=relRelation.GetstrRel();

			if(relRelation.GetFDSet().GetCount()<2)
				continue;

			CFDSet fdset=relRelation.GetFDSet();
			CAttributeSet attsetKey=relRelation.GetKey();
			int nNumFD=fdset.GetCount();

			fdset.GoHeadPosition();
			for(int cJ=0; cJ<nNumFD; cJ++)
			{
				CFD fdFD=fdset.GetFD();
				fdset++;

				CFDSet fdsetTemp;
				fdsetTemp+=(fdFD);

				CAttributeSet attsetCover;
				attsetCover=fdsetTemp.GetCover();
	
				strTemp=attsetCover.GetstrAtt();

				CRelation relUi;
				relUi.SetKey(attsetCover);
				relUi.SetFDSet(fdsetTemp);
				relUi.FindPrimaryKey();

				strTemp=relUi.GetstrFD();

				dbS.AddRel(relUi);
				bChange=TRUE;
			}
			if(bChange==TRUE)
			{
				strTemp=dbS.GetstrRel();

				dbS.DelRel(relRelation);
			
				strTemp=dbS.GetstrRel();
				
				break;
			}
		}
		if(bChange==FALSE)
			break;
	}


	strTemp=dbS.GetstrRel();



	return dbS;
}

/*
CDataBase CRelation::FindBCNF1()
{
	CDataBase dbS;

	CString strTemp;

	// step1
	CFDSet fdsetG=m_fdset.MinumumCover();

	strTemp=fdsetG.GetstrFD();

	//step2
	CRelation relUi;
	relUi.SetKey(m_attsetKey);
	relUi.SetFDSet(fdsetG);
	relUi.FindPrimaryKey();

	dbS.AddRel(relUi);

	//step3
	while(1)
	{
		BOOL bChange=FALSE;
		int nNumRel=dbS.GetCount();

		dbS.GoHeadPosition();
		for(int cI=0; cI<nNumRel; cI++)
		{
			relUi=dbS.GetRel();
			dbS++;

			strTemp=relUi.GetstrRel();

			int nNumSubSet=(int)pow(2, relUi.GetKey().GetCount());
			for(int cJ=1; cJ<nNumSubSet; cJ++)
			{
				CAttributeSet attsetX=relUi.GetKey().GetSubSet(cJ);

				strTemp=attsetX.GetstrAtt();

				int nNumPrimary=relUi.GetCount();
				relUi.GoHeadPosition();
				for(int cK=0; cK<nNumPrimary; cK++)
				{
					if(attsetX!=relUi.GetPrimaryKey())
						break;
				}
				if(attsetX!=relUi.GetPrimaryKey())
				{
					if(attsetX!=relUi.GetKey())
					{
						CAttributeSet attsetA=attsetX.Closure(relUi.GetFDSet());

						strTemp=attsetA.GetstrAtt();

						if(attsetX!=attsetA)
						{
							if(relUi.GetKey().IsMemberOf(attsetX+attsetA))
							{
								dbS.DelRel(relUi);

								CRelation relUj;

								attsetA=attsetA-attsetX;

								strTemp=attsetX.GetstrAtt();

								strTemp=attsetA.GetstrAtt();
							
								relUj.SetKey(relUi.GetKey()-attsetA);
								relUj.SetFDSet(relUi.GetFDSet().DelUesless(relUj.GetKey()));
								relUj.FindPrimaryKey();

								strTemp=relUj.GetstrRel();

								dbS.AddRel(relUj);

								relUj.SetKey(attsetX+attsetA);
								relUj.SetFDSet(relUi.GetFDSet().DelUesless(relUj.GetKey()));
								relUj.FindPrimaryKey();

								strTemp=relUj.GetstrRel();

								dbS.AddRel(relUj);
								bChange=TRUE;
								break;
							}
						}
					}
				}
				if(bChange==TRUE)
					break;
			}
			if(bChange==TRUE)
				break;
		}
		if(bChange==FALSE)
			break;
	}

	
	
	/*
	CDataBase dbS;

	CString strTemp;

	//step1
	CFDSet fdsetG=m_fdset.MinumumCover();
	
	strTemp=fdsetG.GetstrFD();

	//step2
	CRelation relUi;
	CFDSet fdsetGSubSet;
	int nSubSetSize=(int)pow(2, fdsetG.GetCount());

//	for(int i=1; i<=nSubSetSize; i++)
	for(int i=1; i<nSubSetSize; i++)
	{
		fdsetGSubSet=fdsetG.GetSubSet(i, fdsetG.GetCount());

		strTemp=fdsetGSubSet.GetstrFD();

		relUi.SetKey(fdsetGSubSet.GetCover());
		relUi.SetFDSet(fdsetGSubSet);

		strTemp=relUi.GetstrRel();

		dbS.AddRel(relUi);
	}

	strTemp=dbS.GetstrRel();

	//step 3
	BOOL bWellDecomposed=FALSE;
	CAttributeSet attsetKey;

	int nLenOfRelList=dbS.GetCount();
	dbS.GoHeadPosition();
	for(i=0; i<nLenOfRelList; i++)
	{
		relUi=dbS.GetRel();
		dbS++;
		
		if(relUi.GetKey().Closure(fdsetG).IsMemberOf(m_attsetKey))
		{
			bWellDecomposed=TRUE;
			break;
		}
		attsetKey+=relUi.FindKey();

		strTemp=attsetKey.GetstrAtt();

	}

	if(bWellDecomposed==FALSE)
	{
		CFD fdKeyFD;
		fdKeyFD.SetLHS(attsetKey);
		fdKeyFD.SetRHS(m_attsetKey);

		strTemp=fdKeyFD.GetstrFD();

		CRelation relKeyRel;
		relKeyRel.SetKey(attsetKey);
		relKeyRel.SetFDSet((CFDSet)fdKeyFD);

		strTemp=relKeyRel.GetstrRel();

		dbS.AddRel(relKeyRel);
	}

	//step 4

	CDataBase dbSPlus;
	nLenOfRelList=dbS.GetCount();
	dbS.GoHeadPosition();
	for(i=0; i<nLenOfRelList; i++)
	{
		relUi=dbS.GetRel();

		strTemp=relUi.GetstrRel();

		dbS++;

		if(!(relUi.GetKey().IsEmpty()))
			if(!(relUi.GetFDSet().IsEmpty()))
			{
				dbSPlus.AddRel(relUi);

				strTemp=dbSPlus.GetstrRel();

			}
		dbSPlus.RemoveRedundant(relUi);

		strTemp=dbSPlus.GetstrRel();

	}

	return dbSPlus;
	*//*

	strTemp=dbS.GetstrRel();
	return dbS;
}
*/

CRelation& CRelation::operator =(CRelation& relInput)
{
	m_strRelName=relInput.GetRelName();
	m_attsetKey=relInput.GetKey();
	m_fdset=relInput.GetFDSet();
	CAttributeSet attsetTemp;
	
	int nLenOfAttList=relInput.GetCount();

	m_PrimaryList.RemoveAll();

	relInput.GoHeadPosition();
	for(int i=0; i<nLenOfAttList; i++)
	{
		attsetTemp=relInput.GetPrimaryKey();
		relInput++;

		m_PrimaryList.AddTail(attsetTemp);
	}

	m_nIndex=m_PrimaryList.GetCount();
	m_rPosition=m_PrimaryList.GetHeadPosition();

	return *this;
}

void CRelation::operator ++()
{
	m_nIndex++;
	if(m_nIndex>=m_PrimaryList.GetCount())
		m_nIndex=m_PrimaryList.GetCount()-1;
	else
		m_rPosition=m_PrimaryList.FindIndex(m_nIndex);
}

void CRelation::operator ++(int)
{
	operator++();
}

void CRelation::operator --()
{
	m_nIndex--;
	if(m_nIndex<0)
		m_nIndex=0;
	else
		m_rPosition=m_PrimaryList.FindIndex(m_nIndex);
}

void CRelation::operator --(int)
{
	operator--();
}

BOOL CRelation::operator ==(CRelation& relInput)
{
	if(m_attsetKey!=relInput.GetKey())
		return FALSE;

	if(m_fdset!=relInput.GetFDSet())
		return FALSE;

	return TRUE;
}

CString CRelation::GetstrKey()
{
	return m_attsetKey.GetstrAtt();
}

CString CRelation::GetstrPrimaryKey()
{
	CString strTemp;
	const int nListLength=m_PrimaryList.GetCount();
	GoHeadPosition();

	for(int i=0; i<nListLength; i++)
	{
		strTemp+=GetPrimaryKey().GetstrAtt()+"\r\n";
		operator++();
	}

	return strTemp;
}

CString CRelation::GetstrFD()
{
	return m_fdset.GetstrFD();
}

CString CRelation::GetstrRel()
{
	CString strTemp;
	strTemp="Relation\r\n"+m_strRelName+"\r\n";
	strTemp+="Attribute\r\n"+this->GetstrKey()+"\r\n";
	strTemp+="PrimaryKey\r\n"+this->GetstrPrimaryKey()+"\r\n";
	strTemp+="FD\r\n"+this->GetstrFD()+"\r\n";
	return strTemp;
}